/*
Si vuole scrivere un programma C per la gestione delle informazioni relative ai conti correnti online e le relative operazioni. 
Il programma deve prevedere due strutture dati. Una per i conti correnti e l'altra per le operazioni effettuate. 
I conti correnti sono caratterizzati dai seguenti dati: numero conto corrente, nominativo correntista, saldo, tipo di conto ( 0= conto base, 1=conto base pi, 2=conto premium).  
Le operazioni sono caratterizzate dai seguenti dati:  numero conto corrente, codice operazione, data operazione (aaaa/mm/gg), importo operazione, tipo operazione (0=bonifico, 1=imposte, 2= ricariche, 3=utenze).
I conti sono inseriti in un vettore di 3 liste, una per ogni tipo di conto. 
Le operazioni sono inserite in una tabella di 4 righe, una per ogni tipo di operazione. Le righe sono ordinate rispetto alla data.
Scrivere un programma C che codifichi  la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1)	Inserimento di un nuovo conto corrente 
2)	Eliminazione di un conto corrente (chiedere da tastiera il tipo e il numero di conto corrente) 
3)	Inserimento ordinato in tabella di un'operazione. 
4)	Visualizzazione del numero di operazioni in una certa data ( chiedere da tastiera il tipo di conto e la data)
5)	Salvataggio su file dei conti correnti (chiedere tramite tastiera il nome del file).
6)	Lettura da file e inserimento  nel vettore di liste dei conti correnti (chiedere tramite tastiera il nome del file)

Liberare la memoria allocata dinamicamente al termine dell'esecuzione

Non usare variabili globali

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct conto { 
       int numero;
       char nominativo[50];
       int tipo; 
       float saldo;
       };

struct atomo {
       struct conto dato;
       struct atomo *next;
       };
       
      
struct operazione { 
       int numconto;
       int codice;
       char data[20]; 
       float importo;
       int tipop;
       };
      
  void in_lista(struct atomo **L, struct conto c);    
  void ins_conto (struct atomo *L[3]);    
  void elimina (struct atomo *L[3]);    
  void leggi_operazione(struct operazione *o);    
  void ins_ordinato(struct operazione *T[4],int *N, struct operazione o);           
  void vis_operazione(struct operazione *T[4], int *N);
  void salva(struct atomo *L[3]);
 
  void leggi_file(struct atomo *L[3]);


main(){
       struct atomo *L[3], *a;
       struct operazione *T[4];
       struct conto c;
       struct operazione o;
       int N[4],opz,i;
      
      /* inizializzazione  tabella e liste*/ 
       for(i=0;i<4;i++)
       {
        T[i]=NULL;
        N[i]=0;
       }
       
       for(i=0;i<3;i++)
         L[i]=NULL;
          
     
          
       do{
                printf("\nPROGRAMMA PER LA GESTIONE DELLE INFORMAZIONI RELATIVE AI CONTI CORRENTI ONLINE\n");
                printf("\nScegli fra:\n");
                printf("1)Inserimento nuovo conto corrente:\n");
                printf("2)Eliminazione di un conto corrente:\n");
                printf("3)Inserimento di un operazione:\n");
                printf("4)Visualizza numero di operazioni relative ad una certa data:\n");
                printf("5)salvataggio su file dei conti correnti:\n");
                printf("6)Lettura da file e inserimento nel vettore di liste dei conti correnti: \n");
                printf("0) Fine\n\n");
          scanf("%d",&opz);
          switch(opz){
                     
                      case 1: ins_conto(L);
                              break;
                      case 2: elimina (L);
                              break;
                      case 3: leggi_operazione(&o);
                              ins_ordinato(T,N,o);
                              break;
                      case 4: vis_operazione(T,N);
                              break; 
                     case 5: salva(L);
                              break;
                     
                     case 6: leggi_file (L);
                              break;
                          
                          default:;
                     }
          }while(opz!=0);
           for (i=0; i<4; i++)
        T[i]==NULL;
     
     
     for (i=0; i<3 ;i++)
       while (L[i]=NULL)
          {
           a=L[i];
           L[i]=a->next;
           free (a);
          } 
}

void in_lista(struct atomo **L, struct conto c)
{
     struct atomo *aux;
     aux=(struct atomo*)malloc(sizeof(struct atomo));
     if(aux==NULL)
     return;
     aux->dato=c;
     aux->next=*L;
     *L=aux;
}
      
void ins_conto (struct atomo *L[3])
{
     struct conto c;
     int i;
     
     printf ("Numero conto corrente:\n ");
     scanf ("%d", &c.numero);
     printf ("Nominativo: \n");
     scanf ("%s",c.nominativo);
     printf ("Saldo: \n");
     scanf ("%f", &c.saldo);
     printf("Tipo di conto: (0=conto base, 1=conto base piu', 2=conto premium) \n"); 
     scanf ("%d", &c.tipo);
     
     i=c.tipo;
     in_lista(&L[i],c);
}

void elimina (struct atomo *L[3])
{
     struct atomo *l1, *l2;
     int i;
     int numero, tipo;
     
     printf ("Tipo di conto corrente:\n");
     scanf("%d",&tipo);
     
     if(L[tipo]==NULL) 
       {printf("Nessun elemento per questo tipo di conto corrente: \n");
        return;
       } 
     
     printf ("Numero di conto corrente: \n");
     scanf ("%d", &numero);
     
     
     if (L[tipo]->dato.numero==numero) 
       {  
          l1=L[tipo];
          L[tipo]=l1->next;
          free(l1);
          return;
       }
     
      l2=L[tipo];
      l1=l2->next;
      while(l1!=NULL)
         if (l1->dato.numero==numero) 
            {  
              l2->next=l1->next;
              free(l1);
              return;
            }
          else { l2=l2->next;
                 l1=l1->next;
               }
     
     printf("Non trovato\n");
}
           

void leggi_operazione(struct operazione *o)
{    
     printf("Inserisci il numero di conto corrente: \n ");
     scanf("%d",&o->numconto);
     printf("Inserisci il codice operazione: \n");
     scanf("%d",&o->codice);
     printf("Inserisci la data dell'operazione: \n");
     scanf("%s",o->data);
     printf("Inserisci l'importo dell'operazione: \n ");
     scanf("%df", &o->importo);
     printf("Inserisci il tipo di operazione: (0=bonifico, 1=imposte, 2=ricariche, 3=utenze) \n ");
     scanf ("%d", &o->tipop);
}

void ins_ordinato(struct operazione *T[4],int *N, struct operazione o)
{     
       int i,j,f;
     struct operazione *aux;
     
     f=o.numconto;
     aux=realloc(T[f],sizeof(struct operazione )*(N[f]+1));
     if(aux==NULL)
     return;
     T[f]=aux;
     
     for(i=0;i<N[f];i++)
        if(strcmp(o.data,T[f][i].data)<0)
            break;
     
     
     for(j=N[f];j>i;j--)
       T[f][j]=T[f][j-1];
     
     T[f][i]=o;
     N[f]++;
     }


void vis_operazione(struct operazione *T[4], int N[4])
{
     char data[20];
     int tipoconto;
     int i,j;
     int numero=0;
     
     printf("Inserisci la data dell'operazione (aaaa/mm/gg):");
     scanf("%s",data);
     printf("Inserisci il tipo di conto:  (0=conto base, 1=conto base piu', 2=conto premium) \n");
     scanf("%d",&tipoconto);
     
     
     for(i=0;i<4;i++)
         for(j=0;j<N[i];j++)
            if (strcmp(T[i][j].data,data)==0)
               numero++;
            
     printf("Il numero delle operazioni e' %d\n",numero);
}


 
void salva(struct atomo *L[3])
{
     FILE *pf;
     int i;
     char nomefile[80];
     struct atomo *aux;
     struct conto c;
    
     printf("Nome file: ");
     scanf("%s",nomefile);
     
     pf=fopen(nomefile,"w");
     if(pf!=NULL)
        {
           for(i=0;i<3;i++)
               { 
                   aux=L[i];
                   while(aux!=NULL)
                    {
                       c=aux->dato;
                       fwrite(&c,sizeof(struct conto),1,pf);
                       
                       aux=aux->next;
                    }
               }
           fclose(pf);
        }
        
 else printf ("\n Il salvataggio non  avvenuto con successo \n"); }




void leggi_file(struct atomo *L[3])
{
     FILE *pf;
     struct conto c;
     int i;
     char nomefile[80];
      printf("\nNome del file: ");
      scanf("%s",nomefile);
     
     
     
     pf=fopen(nomefile,"r");
     if(pf!=NULL)
     {
          while(fread(&c,sizeof(struct conto),1,pf)!=0)
             {  
               i=c.numero;
               in_lista(&L[i],c);
             }
          fclose(pf);
     }               
} 



