/* 
Si vuole scrivere un programma C per la gestione delle operazioni presso una banca. La banca ha 3 code, una per ogni sportello. Ogni coda  caratterizzata da uno specifico tipo di operazione.
Il programma deve prevedere due strutture dati. Una per le persone che devono essere inserite in coda e l'altra per l'esecuzione dell'operazione. 
Le persone sono caratterizzate dai seguenti dati: codice fiscale, correntista (0=no, 1=si), data di nascita (aaaa/mm/gg),  tipo di operazione.  
Le operazioni sono caratterizzate dai seguenti dati:  codice fiscale, data operazione (aaaa/mm/gg),  importo operazione, tipo di operazione.
Le persone sono inserite in un vettore di 3 code, una per ogni tipo di operazione. 
Le operazioni sono inserite in un vettore di 3 liste, una per ogni tipo di operazione. Le liste sono ordinate rispetto alla data dell'operazione.
Scrivere un programma C che codifichi  la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1)	Inserimento in coda di una persona 
2)	Visualizzazione delle persone presenti in una delle 3 code. ( chiedere tramite tastiera il tipo di operazione).
3)	Inserimento ordinato di un'operazione nel vettore di liste. 
4)	Visualizzazione delle operazioni con un importo maggiore di un valore di soglia letto da tastiera ( Chiedere da tastiera il valore di soglia).
5)	Salvataggio su file delle operazioni 
6)	Lettura da file e inserimento delle operazioni nel vettore di liste

Liberare la memoria allocata dinamicamente al termine dell'esecuzione

Non usare variabili globali


*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



struct persona{
       char cod_fisc[17];
       int  tipo_pers;
       char data[12];
       int tipo_op;
       };
       
struct atomocoda{
       struct persona dato;
       struct atomocoda *next;
       };

struct coda {
       struct atomocoda *primo, *ultimo;
       };
       
struct operazione{
       char cod_fisc[17];
       char data[12];
       float importo;
       int tipo_op;
       };
       
struct atomo {
       struct operazione dato;
       struct atomo *next;
       };
       
void leggi_persona(struct persona *p);
void in_coda(struct coda Q[3], struct persona p);
void visualizza_coda(struct coda Q[3]);       
void leggi_operazione(struct operazione *op);
void in_lista(struct atomo **L, struct operazione op);
void visualizza_lista(struct atomo *L[3]);
void salva(struct atomo *L[3]);
void carica(struct atomo *L[3]);
void da_lista(struct atomo **tl);
     







main ()
{
     struct persona p;
     struct operazione op;
     struct coda Q[3];
     struct atomocoda *aux;
     struct atomo *L[3];
     int i , scelta;
 
 /*Inizializziamo*/ 
 
 for(i=0;i<3;i++)
 {
                 Q[i].primo=NULL;
                 Q[i].ultimo=NULL;
                 L[i]=NULL;
                 }
                 
 
 do{
                 printf("___________GESTIONE OPERAZIONI DI UNA BANCA _________\n\n\n");
                 printf("-----Menu'-----\n\n\n");
                 printf("Scegli tra : \n\n");
                 printf("1)Inserimento in coda di una Persona\n");
                 printf("2)Visualizza persone in coda\n");
                 printf("3)Inserimento operazione\n");
                 printf("4)Visualizzazione operazione\n");
                 printf("5)Salva su file\n");
                 printf("6)Carica da file\n");
                 printf("0)Fine\n");
                 scanf("%d", &scelta);
                 
                 
                 
                 switch(scelta){
                                
                         
                                
                 case 1: leggi_persona(&p);
                         in_coda(Q,p);
                         break;
                         
                 case 2: visualizza_coda(Q);
                         break;
                         
                 case 3: leggi_operazione(&op);
                         in_lista(&L[op.tipo_op], op);
                         break;
                         
                 case 4 : visualizza_lista(L);
                          break;
                          
                 case 5: salva(L);
                         break;
                         
                 case 6: carica(L);
                         break;
                         default:;
                         
                         }
      }while(scelta!=0);
                         
                         
/*Liberiamo la memoria */ 
  
  
  for(i=0;i<3;i++)
        while(Q[i].primo!=NULL)
            {
                aux=Q[i].primo;
                Q[i].primo=aux->next;
                free(aux);
            }
          
      for(i=0;i<3;i++)          
         while(L[i]!=NULL)
           da_lista(&L[i]);
     
     
}     


void leggi_persona(struct persona *p){
    
     printf("Inserisci Il Codice Fiscale: \n");
     scanf("%s", p->cod_fisc);
     printf("Inserisci il Tipo : (Correntista ? 0= NO , 1= SI) \n");
     scanf("%d", &p->tipo_pers);
     printf("Inserisci la Data di Nascita (aaaa/mm/gg): \n");
     scanf("%s", p->data);
     printf("Inserisci il Tipo Operazione ( 0, 1 , 2 ) \n");
     scanf("%d", &p->tipo_op);
     }
     
           
void in_coda(struct coda Q[3], struct persona p)
{    
    int i;
    struct atomocoda *aux;
    
    aux=(struct atomocoda*)malloc(sizeof(struct atomocoda));
    if(aux==NULL)
    return;
    
    i=p.tipo_pers;
    aux->dato=p;
    aux->next=NULL;
    
    if(Q[i].primo==NULL)
         Q[i].primo=aux;
    
    else Q[i].ultimo->next=aux;
    
    Q[i].ultimo=aux;
       
 }

void visualizza_coda(struct coda Q[3])
{
     
    struct atomocoda *aux;
    int tipo_op;
    
    printf("Tipo Operazione(0, 1 , 2  ): ");
    scanf("%d",&tipo_op);
    
    aux = Q[tipo_op].primo;
    
    while(aux!=NULL){
        printf("Codice fiscale: %s\n",aux->dato.cod_fisc);
        printf("Data di nascita (aaaa/mm/gg): %s\n",aux->dato.data);
        aux=aux->next;
        
        }
}

void leggi_operazione(struct operazione *op)
{
     printf("Inserisci il Codice Fiscale : \n");
     scanf("%s", op->cod_fisc);
     printf("Inserisci la Data dell' Operazione (aaaa/mm/gg) : \n");
     scanf("%s", op->data);
     printf("Inserisci Importo Operazione: \n");
     scanf("%f", &op->importo);
     printf("Inserisci il Tipo di Operazione ( 0, 1, 2 ): \n");
     scanf("%d", &op->tipo_op);
     
}


void in_lista(struct atomo **L, struct operazione op)
{
     struct atomo *aux, *l1, *l2;
       
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     
     if(aux==NULL)
     return;
     
     aux->dato=op;
     
     if(*L==NULL || strcmp(op.data, (*L)->dato.data)<0)
        {
          aux->next=*L;
          *L=aux;
          return;
        }
        
     l2=*L;
     l1=l2->next;
     while(l1!=NULL)
       
       if(strcmp(op.data, l1->dato.data)<0)
       break;
       
       else {
              l2=l1;
              l1=l1->next;
            }
     aux->next=l1;
     l2->next=aux;

}     

void visualizza_lista(struct atomo *L[3])
{
   struct atomo *aux;
   struct operazione op;
   int i;                   
   float importo;
                       
   printf("Inserisci l'importo di soglia: ");
   scanf("%f",&importo);
   for(i=0;i<3;i++)
   {
     aux=L[i];
     while(aux!=NULL)
      {   if(aux->dato.importo>importo)
           {
                         printf("Codice Fiscale: %s\n",aux->dato.cod_fisc);
                         printf("Tipo Operazione: %d\n",aux->dato.tipo_op);
                        
            }
          aux=aux->next;            
      }
   }  
}

void salva(struct atomo *L[3])
{      
     FILE *pf;
     struct atomo *aux;
     struct operazione op;
     int i;
     
     
     pf=fopen("operazioni.txt", "w");
     if(pf)
      {
       for(i=0;i<3;i++)
         {
           aux=L[i];
           while(aux!=NULL)
           {
             op=aux->dato;
             fwrite(&op, sizeof(struct operazione),1 ,pf);
             aux=aux->next;
           }  
         }
       fclose(pf);
     }
     
     
 }

void carica(struct atomo *L[3])

{
     
    FILE *pf;
    struct operazione op;
    int i;
    
    pf=fopen("operazioni.txt","r");
    if(pf){
        while(fread(&op,sizeof(struct operazione),1,pf)!=0)
        {
            i=op.tipo_op;
            in_lista(&L[i],op);
        }
        fclose(pf);
        }
 }



void da_lista(struct atomo **tl)
{
    struct atomo *aux;
    aux=*tl;
    *tl=aux->next;
    free(aux);
}            

